diff a/test/lib/jdk/test/lib/hprof/model/InlinedJavaObject.java b/test/lib/jdk/test/lib/hprof/model/InlinedJavaObject.java
--- /dev/null
+++ b/test/lib/jdk/test/lib/hprof/model/InlinedJavaObject.java
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package jdk.test.lib.hprof.model;
+
+import java.io.IOException;
+
+/**
+ * Represents Inlined Java object
+ */
+public class InlinedJavaObject extends JavaObject {
+
+    /**
+     * Construct a new InlinedJavaObject.
+     *
+     * @param clazz the class object
+     * @param offset The offset of field data
+     */
+    public InlinedJavaObject(JavaClass clazz, long offset) {
+        super(clazz, offset);
+    }
+
+    @Override
+    public String toString() {
+        return "inlined " + super.toString();
+    }
+
+    @Override
+    protected final long readValueLength() throws IOException {
+        // TODO: revise - clazz.getInlinedInstanceSize()?
+        return 0;
+    }
+
+    @Override
+    protected long dataStartOffset() {
+        return getOffset();
+    }
+
+}
diff a/test/lib/jdk/test/lib/hprof/model/JavaClass.java b/test/lib/jdk/test/lib/hprof/model/JavaClass.java
--- a/test/lib/jdk/test/lib/hprof/model/JavaClass.java
+++ b/test/lib/jdk/test/lib/hprof/model/JavaClass.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 1997, 2017, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1997, 2022, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -71,10 +71,13 @@
     // Size of an instance, including VM overhead
     private int instanceSize;
     // Total number of fields including inherited ones
     private int totalNumFields;
 
+    // Size of the instance in the object of the class is inlined.
+    // Calculated lazily.
+    private int inlinedInstanceSize = -1;
 
     public JavaClass(long id, String name, long superclassId, long loaderId,
                      long signersId, long protDomainId,
                      JavaField[] fields, JavaStatic[] statics,
                      int instanceSize) {
@@ -112,10 +115,50 @@
     public void resolve(Snapshot snapshot) {
         if (mySnapshot != null) {
             return;
         }
         mySnapshot = snapshot;
+
+        // Resolve inlined fields. Should be done before resolveSuperclass for correct field counting
+        Snapshot.ClassInlinedFields[] inlinedFields = snapshot.findClassInlinedFields(id);
+        if (inlinedFields != null) {
+            int newCount = fields.length;
+            for (Snapshot.ClassInlinedFields f: inlinedFields) {
+                if (f.synthFieldCount == 0) {
+                    // Empty primitive class. just skip it - no data there.
+                    continue;
+                }
+                JavaHeapObject clazz = snapshot.findThing(f.fieldClassID);
+                if (clazz instanceof JavaClass fieldClass) {
+                    fieldClass.resolve(snapshot);
+
+                    // Set new field.
+                    fields[f.fieldIndex] = new InlinedJavaField(f.fieldName, 'Q' + fieldClass.getName() + ';', fieldClass);
+                    newCount -= (f.synthFieldCount - 1);
+                    // Reset invalid fields.
+                    for (int i = 1; i < f.synthFieldCount; i++) {
+                        fields[f.fieldIndex + i] = null;
+                    }
+                } else {
+                    // The field class not found.
+                    System.out.println("WARNING: class of inlined field not found:" + getName() + "." + f.fieldName);
+                }
+            }
+
+            // Set new fields.
+            JavaField[] newFields = new JavaField[newCount];
+            int oldIndex = 0;
+            for (int i = 0; i < newFields.length; i++) {
+                while (fields[oldIndex] == null) {
+                    oldIndex++;
+                }
+                newFields[i] = fields[oldIndex];
+                oldIndex++;
+            }
+            fields = newFields;
+        }
+
         resolveSuperclass(snapshot);
         if (superclass != null) {
             ((JavaClass) superclass).addSubclass(this);
         }
 
@@ -126,10 +169,11 @@
         for (int i = 0; i < statics.length; i++) {
             statics[i].resolve(this, snapshot);
         }
         snapshot.getJavaLangClass().addInstance(this);
         super.resolve(snapshot);
+
         return;
     }
 
     /**
      * Resolve our superclass.  This might be called well before
@@ -375,10 +419,48 @@
      */
     public int getInstanceSize() {
         return instanceSize + mySnapshot.getMinimumObjectSize();
     }
 
+    public int getInlinedInstanceSize() {
+        if (inlinedInstanceSize < 0) {
+            int size = 0;
+            for (JavaField f: fields) {
+                if (f instanceof InlinedJavaField inlinedField) {
+                    size += inlinedField.getInlinedFieldClass().getInlinedInstanceSize();
+                } else {
+                    char sig = f.getSignature().charAt(0);
+                    switch (sig) {
+                        case 'L':
+                        case '[':
+                            size += mySnapshot.getIdentifierSize();
+                            break;
+                        case 'B':
+                        case 'Z':
+                            size += 1;
+                            break;
+                        case 'C':
+                        case 'S':
+                            size += 2;
+                            break;
+                        case 'I':
+                        case 'F':
+                            size += 4;
+                            break;
+                        case 'J':
+                        case 'D':
+                            size += 8;
+                            break;
+                        default:
+                            throw new RuntimeException("unknown field type: " + sig);
+                    }
+                }
+            }
+            inlinedInstanceSize = size;
+        }
+        return inlinedInstanceSize;
+    }
 
     /**
      * @return The size of all instances of this class.  Correctly handles
      *          arrays.
      */
diff a/test/lib/jdk/test/lib/hprof/model/JavaObject.java b/test/lib/jdk/test/lib/hprof/model/JavaObject.java
--- a/test/lib/jdk/test/lib/hprof/model/JavaObject.java
+++ b/test/lib/jdk/test/lib/hprof/model/JavaObject.java
@@ -40,19 +40,24 @@
  */
 public class JavaObject extends JavaLazyReadObject {
 
     private Object clazz;       // Number before resolve
                                 // JavaClass after resolve
+
+    public JavaObject(Object clazz, long offset) {
+        super(offset);
+        this.clazz = clazz;
+    }
+
     /**
      * Construct a new JavaObject.
      *
      * @param classID id of the class object
      * @param offset The offset of field data
      */
     public JavaObject(long classID, long offset) {
-        super(offset);
-        this.clazz = makeId(classID);
+        this(makeId(classID), offset);
     }
 
     public void resolve(Snapshot snapshot) {
         if (clazz instanceof JavaClass) {
             return;
@@ -209,21 +214,21 @@
      *     class ID
      *     data length (int)
      *     byte[length]
      */
     @Override
-    protected final long readValueLength() throws IOException {
+    protected long readValueLength() throws IOException {
         long lengthOffset = getOffset() + 2 * idSize() + 4;
         return buf().getInt(lengthOffset);
     }
 
     @Override
     protected final JavaThing[] readValue() throws IOException {
         return parseFields(false);
     }
 
-    private long dataStartOffset() {
+    protected long dataStartOffset() {
         return getOffset() + idSize() + 4 + idSize() + 4;
     }
 
     private JavaThing[] parseFields(boolean verbose) {
         JavaClass cl = getClazz();
@@ -253,75 +258,81 @@
                 target -= fields.length;
             }
             JavaField f = fields[fieldNo];
             char sig = f.getSignature().charAt(0);
             try {
-                switch (sig) {
-                    case 'L':
-                    case '[': {
-                        long id = objectIdAt(offset);
-                        offset += idSize();
-                        JavaObjectRef ref = new JavaObjectRef(id);
-                        fieldValues[target+fieldNo] = ref.dereference(snapshot, f, verbose);
-                        break;
-                    }
-                    case 'Z': {
-                        byte value = byteAt(offset);
-                        offset++;
-                        fieldValues[target+fieldNo] = new JavaBoolean(value != 0);
-                        break;
-                    }
-                    case 'B': {
-                        byte value = byteAt(offset);
-                        offset++;
-                        fieldValues[target+fieldNo] = new JavaByte(value);
-                        break;
-                    }
-                    case 'S': {
-                        short value = shortAt(offset);
-                        offset += 2;
-                        fieldValues[target+fieldNo] = new JavaShort(value);
-                        break;
-                    }
-                    case 'C': {
-                        char value = charAt(offset);
-                        offset += 2;
-                        fieldValues[target+fieldNo] = new JavaChar(value);
-                        break;
-                    }
-                    case 'I': {
-                        int value = intAt(offset);
-                        offset += 4;
-                        fieldValues[target+fieldNo] = new JavaInt(value);
-                        break;
-                    }
-                    case 'J': {
-                        long value = longAt(offset);
-                        offset += 8;
-                        fieldValues[target+fieldNo] = new JavaLong(value);
-                        break;
-                    }
-                    case 'F': {
-                        float value = floatAt(offset);
-                        offset += 4;
-                        fieldValues[target+fieldNo] = new JavaFloat(value);
-                        break;
-                    }
-                    case 'D': {
-                        double value = doubleAt(offset);
-                        offset += 8;
-                        fieldValues[target+fieldNo] = new JavaDouble(value);
-                        break;
-                    }
-                    default:
-                        throw new RuntimeException("invalid signature: " + sig);
+                if (f instanceof InlinedJavaField inlinedField) {
+                    JavaClass fieldClass = inlinedField.getInlinedFieldClass();
+                    fieldValues[target+fieldNo] = new InlinedJavaObject(fieldClass, offset);
+                    offset += fieldClass.getInlinedInstanceSize();
+                } else {
+                    switch (sig) {
+                        case 'L':
+                        case '[': {
+                            long id = objectIdAt(offset);
+                            offset += idSize();
+                            JavaObjectRef ref = new JavaObjectRef(id);
+                            fieldValues[target + fieldNo] = ref.dereference(snapshot, f, verbose);
+                            break;
+                        }
+                        case 'Z': {
+                            byte value = byteAt(offset);
+                            offset++;
+                            fieldValues[target + fieldNo] = new JavaBoolean(value != 0);
+                            break;
+                        }
+                        case 'B': {
+                            byte value = byteAt(offset);
+                            offset++;
+                            fieldValues[target + fieldNo] = new JavaByte(value);
+                            break;
+                        }
+                        case 'S': {
+                            short value = shortAt(offset);
+                            offset += 2;
+                            fieldValues[target + fieldNo] = new JavaShort(value);
+                            break;
+                        }
+                        case 'C': {
+                            char value = charAt(offset);
+                            offset += 2;
+                            fieldValues[target + fieldNo] = new JavaChar(value);
+                            break;
+                        }
+                        case 'I': {
+                            int value = intAt(offset);
+                            offset += 4;
+                            fieldValues[target + fieldNo] = new JavaInt(value);
+                            break;
+                        }
+                        case 'J': {
+                            long value = longAt(offset);
+                            offset += 8;
+                            fieldValues[target + fieldNo] = new JavaLong(value);
+                            break;
+                        }
+                        case 'F': {
+                            float value = floatAt(offset);
+                            offset += 4;
+                            fieldValues[target + fieldNo] = new JavaFloat(value);
+                            break;
+                        }
+                        case 'D': {
+                            double value = doubleAt(offset);
+                            offset += 8;
+                            fieldValues[target + fieldNo] = new JavaDouble(value);
+                            break;
+                        }
+                        default:
+                            throw new RuntimeException("invalid signature: " + sig);
 
+                    }
                 }
-        } catch (IOException exp) {
-            System.err.println("lazy read failed at offset " + offset);
-            exp.printStackTrace();
-            return Snapshot.EMPTY_JAVATHING_ARRAY;
+            } catch (IOException exp) {
+                System.err.println("lazy read failed at offset " + offset);
+                exp.printStackTrace();
+                return Snapshot.EMPTY_JAVATHING_ARRAY;
             }
         }
         return fieldValues;
     }
 
diff a/test/lib/jdk/test/lib/hprof/model/JavaValueArray.java b/test/lib/jdk/test/lib/hprof/model/JavaValueArray.java
--- a/test/lib/jdk/test/lib/hprof/model/JavaValueArray.java
+++ b/test/lib/jdk/test/lib/hprof/model/JavaValueArray.java
@@ -32,40 +32,18 @@
 
 import java.io.IOException;
 import java.util.Objects;
 
 /**
- * An array of values, that is, an array of ints, boolean, floats or the like.
+ * An array of values, that is, an array of ints, boolean, floats, etc.
+ * or flat array of primitive objects.
  *
  * @author      Bill Foote
  */
 public class JavaValueArray extends JavaLazyReadObject
                 /*imports*/ implements ArrayTypeCodes {
 
-    private static String arrayTypeName(byte sig) {
-        switch (sig) {
-            case 'B':
-                return "byte[]";
-            case 'Z':
-                return "boolean[]";
-            case 'C':
-                return "char[]";
-            case 'S':
-                return "short[]";
-            case 'I':
-                return "int[]";
-            case 'F':
-                return "float[]";
-            case 'J':
-                return "long[]";
-            case 'D':
-                return "double[]";
-            default:
-                throw new RuntimeException("invalid array element sig: " + sig);
-        }
-    }
-
     private static int elementSize(byte type) {
         switch (type) {
             case 'B':
             case 'Z':
                 return 1;
@@ -97,11 +75,11 @@
     protected final long readValueLength() throws IOException {
         long offset = getOffset() + idSize() + 4;
         // length of the array in elements
         long len = buf().getInt(offset);
         // byte length of array
-        return len * elementSize(getElementType());
+        return len * elementSize(getRealElementType());
     }
 
     private long dataStartOffset() {
         return getOffset() + idSize() + 4 + 4 + 1;
     }
@@ -169,20 +147,29 @@
                                   res[i] = new JavaDouble(doubleAt(offset));
                                   offset += 8;
                               }
                               return res;
                 }
+                case 'Q': {
+                    for (int i = 0; i < len; i++) {
+                        res[i] = new InlinedJavaObject(flatArrayElementClass, offset);
+                        offset += flatArrayElementClass.getInlinedInstanceSize();
+                    }
+                    return res;
+                }
                 default: {
                              throw new RuntimeException("unknown primitive type?");
                 }
             }
         }
     }
 
     // JavaClass set only after resolve.
     private JavaClass clazz;
 
+    private long objID;
+
     // This field contains elementSignature byte and
     // divider to be used to calculate length. Note that
     // length of content byte[] is not same as array length.
     // Actual array length is (byte[].length / divider)
     private int data;
@@ -194,32 +181,58 @@
     private static final int LENGTH_DIVIDER_MASK = 0x0FF00;
 
     // Number of bits to shift to get length divider
     private static final int LENGTH_DIVIDER_SHIFT = 8;
 
-    public JavaValueArray(byte elementSignature, long offset) {
+    // Flat array support.
+    private JavaClass flatArrayElementClass;
+
+    public JavaValueArray(long id, byte elementSignature, long offset) {
         super(offset);
+        this.objID = id;
         this.data = (elementSignature & SIGNATURE_MASK);
     }
 
     public JavaClass getClazz() {
         return clazz;
     }
 
+    public boolean isFlatArray() {
+        return flatArrayElementClass != null;
+    }
+
+    public JavaClass getFlatElementClazz() {
+        return flatArrayElementClass;
+    }
+
     public void visitReferencedObjects(JavaHeapObjectVisitor v) {
         super.visitReferencedObjects(v);
     }
 
     public void resolve(Snapshot snapshot) {
         if (clazz instanceof JavaClass) {
             return;
         }
-        byte elementSig = getElementType();
-        clazz = snapshot.findClass(arrayTypeName(elementSig));
-        if (clazz == null) {
-            clazz = snapshot.getArrayClass("" + ((char) elementSig));
+
+        byte elementType = getElementType();
+        String elementSig = "" + (char)elementType;
+        // Check if this is a flat array of primitive objects.
+        Number elementClassID = snapshot.findFlatArrayElementType(objID);
+        if (elementClassID != null) {
+            // This is flat array.
+            JavaHeapObject elementClazz = snapshot.findThing(getIdValue(elementClassID));
+            if (elementClazz instanceof JavaClass elementJavaClazz) {
+                flatArrayElementClass = elementJavaClazz;
+                // need to resolve the element class
+                flatArrayElementClass.resolve(snapshot);
+                elementSig = "Q" + flatArrayElementClass.getName() + ";";
+            } else {
+                // The class not found.
+                System.out.println("WARNING: flat array element class not found");
+            }
         }
+        clazz = snapshot.getArrayClass(elementSig);
         getClazz().addInstance(this);
         super.resolve(snapshot);
     }
 
     public int getLength() {
@@ -241,10 +254,13 @@
                 break;
             case 'J':
             case 'D':
                 divider = 8;
                 break;
+            case 'Q':
+                divider = flatArrayElementClass.getInlinedInstanceSize();
+                break;
             default:
                 throw new RuntimeException("unknown primitive type: " +
                                 elementSignature);
             }
             data |= (divider << LENGTH_DIVIDER_SHIFT);
@@ -255,10 +271,14 @@
     public JavaThing[] getElements() {
         return getValue();
     }
 
     public byte getElementType() {
+        return isFlatArray() ? (byte)'Q' : getRealElementType();
+    }
+
+    private byte getRealElementType() {
         return (byte) (data & SIGNATURE_MASK);
     }
 
     private void checkIndex(int index) {
         Objects.checkIndex(index, getLength());
@@ -277,11 +297,11 @@
     public String valueString(boolean bigLimit) {
         // Char arrays deserve special treatment
         StringBuilder result;
         JavaThing[] things = getValue();
         byte elementSignature = getElementType();
-        if (elementSignature == 'C')  {
+        if (elementSignature == 'C' && !isFlatArray())  {
             result = new StringBuilder();
             for (int i = 0; i < things.length; i++) {
                 result.append(things[i]);
             }
         } else {
diff a/test/lib/jdk/test/lib/hprof/model/Snapshot.java b/test/lib/jdk/test/lib/hprof/model/Snapshot.java
--- a/test/lib/jdk/test/lib/hprof/model/Snapshot.java
+++ b/test/lib/jdk/test/lib/hprof/model/Snapshot.java
@@ -67,10 +67,14 @@
 
     // name-to-class map
     private Map<String, JavaClass> classes =
                  new TreeMap<String, JavaClass>();
 
+    private Map<Number, Number> flatArrays = new HashMap<>();
+
+    private Map<Number, ClassInlinedFields[]> inlinedFields = new HashMap<>();
+
     // new objects relative to a baseline - lazily initialized
     private volatile Map<JavaHeapObject, Boolean> newObjects;
 
     // allocation site traces for all objects - lazily initialized
     private volatile Map<JavaHeapObject, StackTrace> siteTraces;
@@ -207,10 +211,45 @@
         // Add the class
         addFakeClass(makeId(classID), c);
         return c;
     }
 
+    public void addFlatArray(long objID, long elementClassID) {
+        flatArrays.put(makeId(objID), makeId(elementClassID));
+    }
+
+    /**
+     * @return null if the array is not flat array
+     */
+    Number findFlatArrayElementType(long arrayObjectID) {
+        return flatArrays.get(makeId(arrayObjectID));
+    }
+
+    public static class ClassInlinedFields {
+        final int fieldIndex;
+        final int synthFieldCount;
+        final String fieldName;
+        final long fieldClassID;
+
+        public ClassInlinedFields(int fieldIndex, int synthFieldCount, String fieldName, long fieldClassID) {
+            this.fieldIndex = fieldIndex;
+            this.synthFieldCount = synthFieldCount;
+            this.fieldName = fieldName;
+            this.fieldClassID =  fieldClassID;
+        }
+    }
+
+    public void addClassInlinedFields(long classID, ClassInlinedFields[] fields) {
+        inlinedFields.put(makeId(classID), fields);
+    }
+
+    /**
+     * @return null if the class has no inlined fields
+     */
+    ClassInlinedFields[] findClassInlinedFields(long classID) {
+        return inlinedFields.get(makeId(classID));
+    }
 
     /**
      * @return true iff it's possible that some JavaThing instances might
      *          isNew set
      *
diff a/test/lib/jdk/test/lib/hprof/parser/HprofReader.java b/test/lib/jdk/test/lib/hprof/parser/HprofReader.java
--- a/test/lib/jdk/test/lib/hprof/parser/HprofReader.java
+++ b/test/lib/jdk/test/lib/hprof/parser/HprofReader.java
@@ -94,10 +94,16 @@
     static final int HPROF_CPU_SAMPLES   = 0x0d;
     static final int HPROF_CONTROL_SETTINGS = 0x0e;
     static final int HPROF_LOCKSTATS_WAIT_TIME = 0x10;
     static final int HPROF_LOCKSTATS_HOLD_TIME = 0x11;
 
+    static final int HPROF_FLAT_ARRAYS          = 0x12;
+    static final int HPROF_INLINED_FIELDS       = 0x13;
+
+    static final int HPROF_FLAT_ARRAY           = 0x01;
+    static final int HPROF_CLASS_WITH_INLINED_FIELDS = 0x01;
+
     static final int HPROF_GC_ROOT_UNKNOWN       = 0xff;
     static final int HPROF_GC_ROOT_JNI_GLOBAL    = 0x01;
     static final int HPROF_GC_ROOT_JNI_LOCAL     = 0x02;
     static final int HPROF_GC_ROOT_JAVA_FRAME    = 0x03;
     static final int HPROF_GC_ROOT_NATIVE_STACK  = 0x04;
@@ -240,32 +246,31 @@
                     }
                     break;
                 }
 
                 case HPROF_HEAP_DUMP: {
-                    if (dumpsToSkip <= 0) {
+                    if (dumpsToSkip == 0) {
                         try {
                             readHeapDump(length, currPos);
                         } catch (EOFException exp) {
                             handleEOF(exp, snapshot);
                         }
                         if (debugLevel > 0) {
                             System.out.println("    Finished processing instances in heap dump.");
                         }
-                        return snapshot;
                     } else {
                         dumpsToSkip--;
                         skipBytes(length);
                     }
                     break;
                 }
 
                 case HPROF_HEAP_DUMP_END: {
                     if (version >= VERSION_JDK6) {
-                        if (dumpsToSkip <= 0) {
-                            skipBytes(length);  // should be no-op
-                            return snapshot;
+                        if (dumpsToSkip == 0) {
+                            // update dumpsToSkip to skip other dumps
+                            dumpsToSkip--;
                         } else {
                             // skip this dump (of the end record for a sequence of dump segments)
                             dumpsToSkip--;
                         }
                     } else {
@@ -276,11 +281,11 @@
                     break;
                 }
 
                 case HPROF_HEAP_DUMP_SEGMENT: {
                     if (version >= VERSION_JDK6) {
-                        if (dumpsToSkip <= 0) {
+                        if (dumpsToSkip == 0) {
                             try {
                                 // read the dump segment
                                 readHeapDump(length, currPos);
                             } catch (EOFException exp) {
                                 handleEOF(exp, snapshot);
@@ -350,10 +355,19 @@
                 {
                     // Ignore these record types
                     skipBytes(length);
                     break;
                 }
+                case HPROF_FLAT_ARRAYS: {
+                    readFlatArrays(length);
+                    break;
+                }
+                case HPROF_INLINED_FIELDS: {
+                    readInlinedFields(length);
+                    break;
+                }
+
                 default: {
                     skipBytes(length);
                     warn("Ignoring unrecognized record type " + type);
                 }
             }
@@ -850,11 +864,11 @@
             }
         }
         if (primitiveSignature != 0x00) {
             long size = elSize * (long)num;
             bytesRead += size;
-            JavaValueArray va = new JavaValueArray(primitiveSignature, start);
+            JavaValueArray va = new JavaValueArray(id, primitiveSignature, start);
             skipBytes(size);
             snapshot.addHeapObject(id, va);
             snapshot.setSiteTrace(va, stackTrace);
         } else {
             long sz = (long)num * identifierSize;
@@ -900,10 +914,62 @@
                 throw new IOException("Invalid type id of " + typeId);
             }
         }
     }
 
+    private void readFlatArrays(long length) throws IOException {
+        while (length > 0) {
+            byte tag = in.readByte();
+            length--;
+            switch (tag) {
+                case HPROF_FLAT_ARRAY: {
+                    long objId = readID();
+                    length -= identifierSize;
+                    long elementClassId = readID();
+                    length -= identifierSize;
+                    snapshot.addFlatArray(objId, elementClassId);
+                    break;
+                }
+                default: {
+                    throw new IOException("Invalid tag " + tag);
+                }
+            }
+        }
+    }
+
+    private void readInlinedFields(long length) throws IOException {
+        while (length > 0) {
+            byte tag = in.readByte();
+            length--;
+            switch (tag) {
+                case HPROF_CLASS_WITH_INLINED_FIELDS: {
+                    long classID = readID();
+                    length -= identifierSize;
+                    int fieldNum = in.readUnsignedShort();
+                    length -= 2;
+                    Snapshot.ClassInlinedFields[] fields = new Snapshot.ClassInlinedFields[fieldNum];
+                    for (int i = 0; i < fieldNum; i++) {
+                        int fieldIndex = in.readUnsignedShort();
+                        length -= 2;
+                        int synthFieldCount = in.readUnsignedShort();
+                        length -= 2;
+                        String fieldName = getNameFromID(readID());
+                        length -= identifierSize;
+                        long fieldClassId = readID();
+                        length -= identifierSize;
+                        fields[i] = new Snapshot.ClassInlinedFields(fieldIndex, synthFieldCount, fieldName, fieldClassId);
+                    }
+                    snapshot.addClassInlinedFields(classID, fields);
+                    break;
+                }
+                default: {
+                    throw new IOException("Invalid tag " + tag);
+                }
+            }
+        }
+    }
+
     private void handleEOF(EOFException exp, Snapshot snapshot) {
         if (debugLevel > 0) {
             exp.printStackTrace();
         }
         warn("Unexpected EOF. Will miss information...");
